package izziv1;

public class Izziv1 {
    public static void main(String[] args) {
        System.out.println("   n       |     linearno  |   dvojisko  |");
        System.out.println("---------+--------------+------------------");
        for (int i = 20000; i <= 1000000; i += 20000) {
            System.out.printf("    %d |         %d |           %d\n", i, timeLinear(i), timeBinary(i));
        }
    }

    static int[] generateTable(int n) {
        int[] table = new int[n];
        for (int i = 0; i < n; i++) {
            table[i] = i + 1;
        }
        return table;
    }

    static int findLinear(int[] a, int v) {
        for (int i = 0; i < a.length; i++) {
            if (a[i] == v) {
                return i;
            }
        }
        return -1;
    }

    static int findBinary(int[] a, int l, int r, int v) {
        int center = l + (r - l) / 2;

        if (a[center] == v) {
            return center;
        }

        if (a[center] > v) {
            return findBinary(a, l, center, v);
        }
        return findBinary(a, center + 1, r, v);
    }

    static long timeLinear(int n) {
        int[] table = generateTable(n);
        long startTime = System.nanoTime();
        for (int i = 0; i < 1000; i++) {
            int num = (int)(Math.random() * n);
            int _ = findLinear(table, num);
        }
        return (System.nanoTime() - startTime) / 1000;
    }

    static long timeBinary(int n) {
        int[] table = generateTable(n);
        long startTime = System.nanoTime();
        for (int i = 0; i < 1000; i++) {
            int num = (int)(Math.random() * n) + 1;
            int _ = findBinary(table, 0, n - 1, num);
        }
        return (System.nanoTime() - startTime) / 1000;
    }
}