package izziv3;

import java.util.ArrayList;

public class Izziv3 {
    public static void main(String[] args) {
        int size = Integer.parseInt(args[0]);

        StdDraw.setCanvasSize(1500, 800);
        StdDraw.setXscale(-1, size);
        StdDraw.setYscale((int) (Math.log(size + 1) / Math.log(2)) + 1, -1);

        CompleteBinaryTreeDrawer ctd = new CompleteBinaryTreeDrawer(size);

        ctd.drawPreorder(0);
    }
}

class CompleteBinaryTreeDrawer {
    char[] data;
    int[] x, y;
    ArrayList<Integer> inorder;
    final int size;

    double xScale, yScale;

    public CompleteBinaryTreeDrawer(int size) {
        this.size = size;
        data = new char[size];
        x = new int[size];
        y = new int[size];
        inorder = new ArrayList<>();
        inorder(0);

        xScale = size;
        yScale = (int) (Math.log(size + 1) / Math.log(2)) + 1;

        for (int i = 0; i < size; i++) {
            data[i] = (char) ('A' + i);
            x[i] = inorder.indexOf(i);
            y[i] = (int) (Math.log(i + 1) / Math.log(2));
        }
    }

    void inorder(int i) {
        if (2 * i + 1 < size) {
            inorder(i * 2 + 1);
        }
        inorder.add(i);
        if (2 * i + 2 < size) {
            inorder(2 * i + 2);
        }
    }

    void drawNode(int i) {
        StdDraw.filledEllipse(x[i], y[i], xScale * 0.01, yScale * 0.02);
    }

    void drawEdgeToNode(int i) {
        int o = (i - 1) / 2;
        StdDraw.line(x[o], y[o], x[i], y[i]);
    }

    void drawLevelorder() {
        drawNode(0);
        for (int i = 0; i < size; i++) {
            drawEdgeToNode(i);
            drawNode(i);
        }
    }

    void drawPreorder(int i) {
        drawEdgeToNode(i);
        drawNode(i);
        if (2 * i + 1 < size) {
            drawInorder(i * 2 + 1);
        }
        if (2 * i + 2 < size) {
            drawInorder(2 * i + 2);
        }
    }

    void drawInorder(int i) {
        if (2 * i + 1 < size) {
            drawInorder(i * 2 + 1);
        }
        drawEdgeToNode(i);
        drawNode(i);
        if (2 * i + 2 < size) {
            drawInorder(2 * i + 2);
        }
    }

    void drawPostorder(int i) {
        if (2 * i + 1 < size) {
            drawInorder(i * 2 + 1);
        }
        if (2 * i + 2 < size) {
            drawInorder(2 * i + 2);
        }
        drawEdgeToNode(i);
        drawNode(i);
    }

    int traverse(int i, int x, int y) {
        if (2 * i + 1 < size) {
            x = traverse(2 * i + 1, x, y + 1);
        }
        this.x[i] = x;
        this.y[i] = y;
        if (2 * i + 2 < size) {
            x = traverse(2 * i + 2, x + 1, y + 1);
        }
        return x + 1;
    }
}